package be.iminds.ilabt.jfed.ui.cli2.instruction;

import be.iminds.ilabt.jfed.experiment.setup.config.Slice;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

public class DeleteInstruction extends InstructionWithSlice {
    @JsonCreator
    public DeleteInstruction(@JsonProperty("action") @Nonnull Action action,
                             @JsonProperty("user") @Nullable User user,
                             @JsonProperty("actionOutputs") @Nullable List<ActionOutput> actionOutputs,
                             @JsonProperty("debugOutputs") @Nullable List<DebugOutput> debugOutputs,
                             @JsonProperty("callOutputs") @Nullable List<CallOutput> callOutputs,
                             @JsonProperty("proxy") @Nullable ProxySettings proxy,
                             @JsonProperty("slice") Slice slice) {
        super(action, user, actionOutputs, debugOutputs, callOutputs, proxy, slice);
    }

    private DeleteInstruction(boolean demo) {
        super(Action.DELETE, demo, true);
    }

    @JsonIgnore
    @Nonnull
    @Override
    public Action getActionOfClass() {
        return Action.DELETE;
    }
}
